﻿var Protocol = {
	xhr: null,
	
	last_index1: null,
	last_name1: null,
	last_index2: null,
	last_name2: null,
	last_date: null
}

Protocol.init = function() {
	console.log('Protocol.init();');
	return true;
}

Protocol.deInit = function() {
	console.log('Protocol.deInit();');
}



////////////////
//Send Request//
////////////////

//get station data
Protocol.getStationData = function(_index, _str) {
	Protocol.last_index1 = _index;
	Protocol.last_index2 = null;
	Protocol.last_name1 = null;
	Protocol.last_name2 = null;
	
	GUI.clearData();
	GUI.setScreen('selectStation');
	Back.add('selectStation', {
		index: _index,
		str: _str
	});
	
	
	xhr = new XMLHttpRequest();
	xhr.onreadystatechange = Protocol.onStationData;
	
	GUI.currentStation = _index;
	
	console.log('_str ' + _str);
	
	md5Str = '';
	if (_str) {
		additionStr = _str.split('&');
		for (var i = 0; i < additionStr.length; i++) {
			md5Str += additionStr[i].split('=')[1];
		}
		_str = '&' + _str;
	} else {
		_str = '';
	}
	console.log('md5Str ' + md5Str + '   _str ' + _str);
	
	var md5hash = md5(define.MD5 + _index + md5Str);
	var requestStr = (GUI.currentCity == 0 ? define.BASE_URL : define.BASE_URL_SPB);
	requestStr += "station.php?nnst=" + _index + "&crc=" + md5hash + _str;
	
	
	console.log(requestStr);
	//alert(requestStr);
	if (define.DEBUG) 
		requestStr = "station.xml";
	console.log(requestStr);
	
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	} catch (e) {
	}
	xhr.open("GET", requestStr);
	xhr.send(null);
}

//get train data
Protocol.getTrainData = function(_index, _date) {
	Protocol.last_name1 = null;
	Protocol.last_name2 = null;
	Protocol.last_date = _date;
	
	GUI.clearData();
	GUI.setScreen('selectTrain');
	Back.add('selectTrain', {
		index: _index,
		date: _date
	});
	
	if (_date) _date = Protocol.checkDate(_date);
	
	xhr = new XMLHttpRequest();
	xhr.onreadystatechange = Protocol.onTrainData;
	
	var md5hash = md5(define.MD5 + _index + (_date ? _date : ""));
	var requestStr = (GUI.currentCity == 0 ? define.BASE_URL : define.BASE_URL_SPB);
	requestStr += "view.php?np=" + _index +
	(_date ? ("&date=" + _date) : "") +
	"&crc=" +
	md5hash;
	
	console.log(requestStr);
	if (define.DEBUG) 
		requestStr = "view.xml";
	console.log(requestStr);
	
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	} catch (e) {
	}
	xhr.open("GET", requestStr);
	xhr.send(null);
}

//get 2stations rasp data
Protocol.getRaspData = function(_index1, _index2, _date) {
	Protocol.last_index1 = _index1;
	Protocol.last_index2 = _index2;
	Protocol.last_date = _date;
	Protocol.last_name1 = null;
	Protocol.last_name2 = null;
	
	GUI.clearData();
	GUI.setScreen('selectRasp');
	Back.add('selectRasp', {
		index1: _index1,
		index2: _index2,
		date: _date
	});
	
	if (_date) _date = Protocol.checkDate(_date);
	
	
	xhr = new XMLHttpRequest();
	xhr.onreadystatechange = Protocol.onRaspData;
	
	var md5hash = md5(define.MD5 + _index1 + _index2 + (_date ? _date : ""));
	var requestStr = (GUI.currentCity == 0 ? define.BASE_URL : define.BASE_URL_SPB);
	requestStr += "rasp.php?st1=" + _index1 + "&st2=" + _index2 +
	(_date ? ("&date=" + _date) : "") +
	"&crc=" +
	md5hash;
	
	console.log(requestStr);
	if (define.DEBUG) 
		requestStr = "rasp.xml";
	console.log(requestStr);
	
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	} catch (e) {
	}
	xhr.open("GET", requestStr);
	xhr.send(null);
}

//get 3stations rasp data
Protocol.getRasp2Data = function(_index1, _index2, _date, _station) {
	GUI.clearData();
	GUI.setScreen('selectRasp2');
	Back.add('selectRasp2', {
		index1: _index1,
		index2: _index2,
		date: _date,
		station: _station
	});
	
	if (_date) _date = Protocol.checkDate(_date);
	
	xhr = new XMLHttpRequest();
	xhr.onreadystatechange = Protocol.onRasp2Data;
	
	var md5hash = md5(define.MD5 + _index1 + _index2 + (_date ? _date : "") + (_station ? _station : ""));
	var requestStr = (GUI.currentCity == 0 ? define.BASE_URL : define.BASE_URL_SPB);
	requestStr += "rasp_change.php?st1=" + _index1 + "&st2=" + _index2 +
	(_date ? ("&date=" + _date) : "") +
	(_station ? ("&station=" + _station) : "") +
	"&crc=" +
	md5hash;
	
	//alert( requestStr );
	console.log(requestStr);
	if (define.DEBUG) 
		requestStr = "rasp_change.xml";
	console.log(requestStr);
	
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	} catch (e) {
	}
	xhr.open("GET", requestStr);
	xhr.send(null);
}


//get current stations on map;
Protocol.getCurrentStations = function(requestStr) {
	xhr = new XMLHttpRequest();
	xhr.onreadystatechange = Protocol.onGetCurrentStations;
	
	console.log(requestStr);
	
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	} catch (e) {
	}
	xhr.open("GET", requestStr);
	xhr.send(null);
}




///////////////
//Get Results//
///////////////

Protocol.onStationData = function() {
	if (xhr.readyState == 4) {
		if (xhr.status == 200) {
			console.log("onStationData success loaded");
			
			var error = xhr.responseXML.getElementsByTagName('error');
			if (error.length) {
				error = error[0].textContent;
				if (GUI.currentScreen == 'selectStation') {
					$('content').innerHTML = '<div class="error center">' + error + '</div>';
					Main.onscroll();
				}
				console.log("onStationData loaded: " + error);
				return;
			}
			
			var notrain = xhr.responseXML.getElementsByTagName('notrain');
			if (notrain.length) {
				notrain = notrain[0].textContent;
				if (GUI.currentScreen == 'selectStation') {
					$('content').innerHTML = '<div class="center">' + notrain + '</div>';
					Main.onscroll();
				}
				console.log("onTrainData loaded: " + notrain);
				return;
			}
			
			var feed = '';
			
			if (xhr.responseText == null) {
				if (GUI.currentScreen == 'selectStation') {
					$('content').innerHTML = '<div class="center">' + define.NO_CONNECT + '</div>';
					Main.onscroll();
				}
				return;
			}
			
			var st_name = xhr.responseXML.getElementsByTagName('st-nam');
			if (st_name.length) 
				st_name = st_name[0].textContent;
			//feed += '<div class="topHeader center">Станция ' + st_name + '</div><br/>';
			
			feed += '<div class="contentText center">Расписание станции</div>';
			feed += '<div class="contentText center">';
			feed += st_name;
			feed += '</div>';
			
			Protocol.last_name1 = st_name;
			
			var dir = xhr.responseXML.getElementsByTagName('dir');
			if (dir.length) 
				dir = dir[dir.length - 1].textContent;
			
			
			
			var dir_list = xhr.responseXML.getElementsByTagName('dir');
			//feed += '<div class="topHeader center">Направление: ';
			
			GUI.menulist = '<div>';
			for (var i = 0, len = dir_list.length, count = 0; i < len - 1; i++) {
				dir_name = dir_list[i].getElementsByTagName('nam');
				if (dir_name.length) 
					dir_name = dir_name[0].textContent;
				
				dir_url = dir_list[i].getElementsByTagName('url');
				if (dir_url.length) 
					dir_url = dir_url[0].textContent;
				
				splitUrl = dir_url.split("&");
				var protocolList = '';
				for (var j = 2; j < splitUrl.length; j++) {
					protocolList += splitUrl[j];
					if (j < splitUrl.length - 1) 
						protocolList += "&";
				}
				var clickFeed = GUI.currentStation + ", '" + protocolList + "'";
				
				//TODO form direction menulist
				if (dir_name != dir) {
					GUI.menulist += '<div class="buttontext_menu" onclick="Protocol.getStationData(' + clickFeed + ')" feedback="50">';
					GUI.menulist += dir_name;
					GUI.menulist += '</div>';
					count++;
				}
				//feed += '<div class="center direction' + ( dir_name == dir ? "_current" : "" );  
				//feed += '" onclick="Protocol.getStationData(' + clickFeed + ')"> ' + dir_name + '</div>';
			}
			//feed += '</div><br/>';		
			GUI.menulist += '</div>';
			
			
			var trains = xhr.responseXML.getElementsByTagName('tra');
			var dep_name, arr_name, time, regime, url;
			GUI.trainList = new Array;
			
			feed += '<br/><table style="width:100%">';
			for (var i = 0, len = trains.length; i < len; i++) {
				if (i != 0) 
					feed += '<tr><td colspan="2" class="setBorder"></td></tr>';
				
				
				dep_name = trains[i].getElementsByTagName('dep-st');
				dep_name = dep_name[0].getElementsByTagName('nam');
				if (dep_name.length) 
					dep_name = dep_name[0].textContent;
				
				arr_name = trains[i].getElementsByTagName('arr-st');
				arr_name = arr_name[0].getElementsByTagName('nam');
				if (arr_name.length) 
					arr_name = arr_name[0].textContent;
				
				url = trains[i].getElementsByTagName('ro-url');
				if (url.length) 
					url = url[0].textContent;
				
				var splitUrl = url.split("?");
				var splitUrl0 = splitUrl[1].split("=")[1];
				
				GUI.trainList.push(splitUrl0);
				
				time = trains[i].getElementsByTagName('tim');
				if (time.length) 
					time = time[0].textContent;
				feed += '<tr><td rowspan="2" class="time_st" onclick="GUI.clickStation(' + i + ');">';
				feed += time;
				feed += '</td><td class="stations_st"  onclick="GUI.clickStation(' + i + ');">';
				feed += dep_name + ' &rarr ' + arr_name;
				feed += '</td></tr>';
				
				feed += '<tr>';
				
				
				regime = trains[i].getElementsByTagName('sch');
				if (regime.length) 
					regime = regime[0].textContent;
				if (regime == "отменен" || regime == "по выходным") {
					feed += '<td class="regime_st" style="color:#f00">' + regime + '</td></tr>';
				} else if (regime != "ежедневно") {
					feed += '<td class="regime_st">' + regime + '</td></tr>';
				} else {
					feed += '<td class="regime_st"></td> </tr>';
				}
				
				
				//pla	Номер платформы. Значение может быть (пусто)
				//typ	Тип поезда (ускоренная, экспресс). Для обычных электричек (пусто)
				//cha	Временные изменения. Значение может быть (пусто)
			
			
			}
			feed += '</table>';
			feed += '<br/><br/><br/>';
			
			//Attach the Feed to the HTML
			console.log('GUI.currentScreen ' + GUI.currentScreen);
			if (GUI.currentScreen == 'selectStation') {
				$('content').innerHTML = feed;
				$('input3_td').innerHTML = dir;
				//show change direction
				if (count > 0 && !GUI.showMenu) 
					Helper.show('menubottom', true);
				Main.onscroll();
			}
		} else {
			//Handle other scenarios, such as timeouts...
			if (GUI.currentScreen == 'selectStation') {
				$('content').innerHTML = '<div class="dateSelect">Сервер недоступен! Проверьте настройки соединения.</div>';
			}
			Main.onscroll();
		}
	} else {
	}
}


Protocol.onTrainData = function() {
	if (xhr.readyState == 4) {
		if (xhr.status == 200) {
			console.log("onTrainData success loaded");
			
			var error = xhr.responseXML.getElementsByTagName('error');
			if (error.length) {
				error = error[0].textContent;
				if (GUI.currentScreen == 'selectTrain') {
					$('content').innerHTML = '<div class="error center">' + error + '</div>';
					Main.onscroll();
				}
				console.log("onTrainData loaded: " + error);
				return;
			}
			
			var notrain = xhr.responseXML.getElementsByTagName('notrain');
			if (notrain.length) {
				notrain = notrain[0].textContent;
				if (GUI.currentScreen == 'selectTrain') {
					$('content').innerHTML = '<div class="center">' + notrain + '</div>';
					Main.onscroll();
				}
				console.log("onTrainData loaded: " + notrain);
				return;
			}
			if (xhr.responseText == null) {
				if (GUI.currentScreen == 'selectTrain') {
					$('content').innerHTML = '<div class="center">' + define.NO_CONNECT + '</div>';
					Main.onscroll();
				}
				return;
			}
			
			//Станция отправления
			var dep_name = xhr.responseXML.getElementsByTagName('dep-st');
			dep_name = dep_name[0].getElementsByTagName('nam');
			if (dep_name.length) 
				dep_name = dep_name[0].textContent;
			
			//Станция прибытия		
			var arr_name = xhr.responseXML.getElementsByTagName('arr-st');
			arr_name = arr_name[0].getElementsByTagName('nam');
			if (arr_name.length) 
				arr_name = arr_name[0].textContent;
			
			//Дата отправления. Значение может быть (пусто)
			var time = xhr.responseXML.getElementsByTagName('dat');
			if (time.length) 
				time = time[0].textContent;
			
			var dep_num = xhr.responseXML.getElementsByTagName('ref-dep-st-num');
			if (dep_num.length) 
				dep_num = dep_num[0].textContent;
			else dep_num = -1;
			
			var arr_num = xhr.responseXML.getElementsByTagName('ref-arr-st-num');
			if (arr_num.length) 
				arr_num = arr_num[0].textContent;
			else arr_num = -1;
			
			
			//Режим движения поезда
			var regime = xhr.responseXML.getElementsByTagName('tr');
			regime = regime[0].getElementsByTagName('sch');
			if (regime.length) 
				regime = regime[0].textContent;
			
			
			var feed = '';
			feed += '<div class="contentText center">Расписание электрички</div>';
			feed += '<div class="contentText center">';
			feed += dep_name;
			feed += ' &rarr ';
			feed += arr_name;
			feed += '</div>';
			
			if (regime) {
				feed += '<div class="contentText center">Режим движения: ';
				feed += regime;
				feed += '</div>';
			}
			
			
			feed += '<br/><table style="width:100%">';
			
			var stations = xhr.responseXML.getElementsByTagName('st');
			var st_name, arr_time, dep_time, url;
			GUI.stationList = new Array;
			
			for (var i = 0, len = stations.length; i < len; i++) {
				//nam	Название станции
				st_name = stations[i].getElementsByTagName('nam');
				if (st_name.length) 
					st_name = st_name[0].textContent;
				
				//num	Индекс станции
				st_num = stations[i].getElementsByTagName('num');
				if (st_num.length) 
					st_num = st_num[0].textContent;
				
				//url	Ссылка на страницу расписания по станции
				url = stations[i].getElementsByTagName('url');
				if (url.length) 
					url = url[0].textContent;
				
				//arr-tim	Время прибытия на станцию
				arr_time = stations[i].getElementsByTagName('arr-tim');
				if (arr_time.length) 
					arr_time = arr_time[0].textContent;
				
				//dep-tim	Время отправления со станции
				dep_time = stations[i].getElementsByTagName('dep-tim');
				if (dep_time.length) 
					dep_time = dep_time[0].textContent;
				
				GUI.stationList.push(st_num);
				
				//if ( st_num == dep_num || st_num == arr_num ) currentClass = " bold";
				if (st_num == GUI.searchData[0].index || st_num == GUI.searchData[1].index) 
					currentClass = " bold";
				else currentClass = '';
				
				
				if (i != 0) 
					feed += '<tr><td colspan="2" class="setBorder"></td></tr>';
				
				feed += '<tr class="item" onclick="GUI.clickTrain(' + i + ')">';
				feed += '<td class="stations_tr';
				feed += currentClass;
				feed += '">';
				feed += st_name;
				feed += '</td><td class="time_st';
				feed += currentClass;
				feed += '">';
				feed += arr_time;
				//feed += ' - ';
				//feed += dep_time;
				feed += '</td></tr>';
				
			}
			feed += '</table>';
			feed += '<br/><br/><br/>';
			
			
			//Attach the Feed to the HTML
			if (GUI.currentScreen == 'selectTrain') {
				$('content').innerHTML = feed;
				Main.onscroll();
			}
		} else {
			//Handle other scenarios, such as timeouts...
			if (GUI.currentScreen == 'selectTrain') {
				$('content').innerHTML = '<div class="dateSelect">Сервер недоступен! Проверьте настройки соединения.</div>';
			}
			Main.onscroll();
		}
	} else {
	}
}

Protocol.onRaspData = function() {
	if (xhr.readyState == 4) {
		if (xhr.status == 200) {
			console.log("onRaspData success loaded");
			
			var error = xhr.responseXML.getElementsByTagName('error');
			if (error.length) {
				error = error[0].textContent;
				if (GUI.currentScreen == 'selectRasp') {
					$('content').innerHTML = '<div class="error center">' + error + '</div>';
					Main.onscroll();
				}
				console.log("onRaspData loaded: " + error);
				return;
			}
			
			var notrain = xhr.responseXML.getElementsByTagName('notrain');
			if (notrain.length) {
				notrain = notrain[0].textContent;
				feed = '<div class="center">' + notrain + '</div>';
				console.log("onRaspData loaded: " + notrain);
				
				var change = xhr.responseXML.getElementsByTagName('ch-url');
				if (change.length) {
					feed += '<div class="cityItem center" onclick="Protocol.getRasp2Data(' +
					Protocol.last_index1 +
					', ' +
					Protocol.last_index2 +
					', ' +
					Protocol.last_date +
					');">' +
					define.RASP_CHANGE_TEXT +
					'</div>';
					
					
				}
				
				if (GUI.currentScreen == 'selectRasp') {
					if (change.length) {
						Back.backList.pop();
						Protocol.getRasp2Data(Protocol.last_index1, Protocol.last_index2, Protocol.last_date);
					} else {
						$('content').innerHTML = feed;
						Main.onscroll();
					}
				}
				return;
			}
			if (xhr.responseText == null) {
				if (GUI.currentScreen == 'selectRasp') {
					$('content').innerHTML = '<div class="center">' + define.NO_CONNECT + '</div>';
					Main.onscroll();
				}
				return;
			}
			
			var feed = '';
			
			//Станция отправления
			var dep_name = xhr.responseXML.getElementsByTagName('dep-st-nam');
			//dep_name = dep_name[0].getElementsByTagName('nam');
			if (dep_name.length) 
				dep_name = dep_name[0].textContent;
			//feed += '<div class="topHeader">Станция отправления:     ' + dep_name + '</div>';
			var dep_name_ = dep_name;
			Protocol.last_name1 = dep_name;
			
			//Станция прибытия		
			var arr_name = xhr.responseXML.getElementsByTagName('arr-st-nam');
			//arr_name = arr_name[0].getElementsByTagName('nam');
			if (arr_name.length) 
				arr_name = arr_name[0].textContent;
			//feed += '<div class="topHeader">Станция прибытия:     ' + arr_name + '</div>';
			var arr_name_ = arr_name;
			Protocol.last_name2 = arr_name;
			
			//Дата отправления. Значение может быть (пусто)
			var time = xhr.responseXML.getElementsByTagName('dat');
			if (time.length) 
				time = time[0].textContent;
			//if (time) feed += '<br/><div class="topHeader">Дата отправления:     ' + time + '</div>';
			
			
			//pri	Стоимость разового проезда. Значение может быть (пусто)
			var pri = xhr.responseXML.getElementsByTagName('pri');
			if (pri.length) 
				pri = pri[0].textContent;
			
			
			
			var trains = xhr.responseXML.getElementsByTagName('tra');
			GUI.stationList = [];
			
			feed += '<br/><table style="width:100%">';
			for (var i = 0, len = trains.length; i < len; i++) {
			
				dep = trains[i].getElementsByTagName('dep');
				dep_time = dep[0].getElementsByTagName('tim');
				if (dep_time.length) 
					dep_time = dep_time[0].textContent;
				
				dep_pla = dep[0].getElementsByTagName('pla');
				if (dep_pla.length) 
					dep_pla = dep_pla[0].textContent;
				
				dep = dep[0].getElementsByTagName('st');
				dep_name = dep[0].getElementsByTagName('nam');
				if (dep_name.length) 
					dep_name = dep_name[0].textContent;
				
				arr = trains[i].getElementsByTagName('arr');
				arr_time = arr[0].getElementsByTagName('tim');
				if (arr_time.length) 
					arr_time = arr_time[0].textContent;
				
				arr_pla = arr[0].getElementsByTagName('pla');
				if (arr_pla.length) 
					arr_pla = arr_pla[0].textContent;
				
				arr = arr[0].getElementsByTagName('st');
				arr_name = arr[0].getElementsByTagName('nam');
				if (arr_name.length) 
					arr_name = arr_name[0].textContent;
				
				tr_tim = trains[i].getElementsByTagName('tr-tim');
				if (tr_tim.length) 
					tr_tim = tr_tim[0].textContent;
				
				url = trains[i].getElementsByTagName('ro-url');
				if (url.length) 
					url = url[0].textContent;
				
				///xml/view.php?np=e704ca87&date=2010-12-02
				url = url.split('?')[1];
				//console.log('url ' + url);
				url = url.split('&');
				//console.log('url ' + url);
				
				var setUrl = '';
				t = '';
				for (var j = 0; j < url.length; j++) {
					t = url[j].split("=")[1];
					setUrl += "'" + t + "'";
					if (j < url.length - 1) 
						setUrl += ", ";
				}
				//console.log('setUrl: ' + setUrl);
				
				if (i != 0) 
					feed += '<tr><td colspan="3" class="setBorder"></td></tr>';
				
				
				feed += '<tr onclick="Protocol.getTrainData(' + setUrl + ')">';
				feed += '<td class="time_rt">';
				feed += dep_time;
				feed += '</td><td class="time_wait">';
				
				tr_tim_arr = tr_tim.split(':');
				tr_tim_arr[0] = parseInt(tr_tim_arr[0], 10);
				tr_tim_arr[1] = parseInt(tr_tim_arr[1], 10);
				tr_tim_arr[2] = parseInt(tr_tim_arr[2], 10);
				
				feed += Protocol.checkHour( tr_tim_arr[0] );
				feed += Protocol.checkMin( tr_tim_arr[1] );
				feed += Protocol.checkSec( tr_tim_arr[2] );
				
				feed += '</td><td class="time_rt">';
				feed += arr_time;
				feed += '</td></tr>';
				
				feed += '<tr onclick="Protocol.getTrainData(' + setUrl + ')">';
				feed += '<td class="stations_rt" colspan="3">';
				feed += dep_name;
				feed += ' &rarr ';
				feed += arr_name;
				
				regime = trains[i].getElementsByTagName('sch');
				if (regime.length) 
					regime = regime[0].textContent;
				if (regime == "отменен" || regime == "по выходным") {
					feed += ',  <span style="color:#f00">' + regime + '</span>';
				} else if (regime != "ежедневно") {
					feed += ',  <span>' + regime + '</span>';
				}
				feed += '</td></tr>';
			}
			feed += '</table>';
			feed += '<br/><br/><br/>';
			
			
			//Attach the Feed to the HTML
			if (GUI.currentScreen == 'selectRasp') {
				if (pri) {
					GUI.setStatus('<div class="ticket_cost">Цена билета: ' + pri + ' руб.</div>');
					Helper.show('statusBar', true);
					GUI.setPadding();
				} else {
					GUI.setStatus('');
					Helper.show('statusBar', false);
					GUI.setPadding();
				}
				$('content').innerHTML = feed;
				Main.onscroll();
			}
		} else {
			//Handle other scenarios, such as timeouts...
			if (GUI.currentScreen == 'selectRasp') {
				$('content').innerHTML = '<div class="dateSelect">Сервер недоступен! Проверьте настройки соединения.</div>';
			}
			Main.onscroll();
		}
	} else {
	}
}

Protocol.onRasp2Data = function() {
	if (xhr.readyState == 4) {
		if (xhr.status == 200) {
			console.log("onRasp2Data success loaded");
			
			var error = xhr.responseXML.getElementsByTagName('error');
			if (error.length) {
				error = error[0].textContent;
				if (GUI.currentScreen == 'selectRasp2') {
					$('content').innerHTML = '<div class="error center">' + error + '</div>';
					Main.onscroll();
				}
				console.log("onRaspData loaded: " + error);
				return;
			}
			
			var notrain = xhr.responseXML.getElementsByTagName('notrain');
			if (notrain.length) {
				notrain = notrain[0].textContent;
				if (GUI.currentScreen == 'selectRasp2') {
					$('content').innerHTML = '<div class="center">' + notrain + '</div>';
					Main.onscroll();
				}
				console.log("onRaspData loaded: " + notrain);
				return;
			}
			if (xhr.responseText == null) {
				if (GUI.currentScreen == 'selectRasp2') {
					$('content').innerHTML = '<div class="center">' + define.NO_CONNECT + '</div>';
					Main.onscroll();
				}
				return;
			}
			
			var feed = '';
			//<div class="topHeader center">Расписание электричек</div>';
			
			//Станция отправления
			var dep_name = xhr.responseXML.getElementsByTagName('dep-st');
			dep_st_num = dep_name[0].getElementsByTagName('num');
			if (dep_st_num.length) 
				dep_st_num = dep_st_num[0].textContent;
			dep_name = dep_name[0].getElementsByTagName('nam');
			if (dep_name.length) 
				dep_name = dep_name[0].textContent;
			
			
			//Станция прибытия		
			var arr_name = xhr.responseXML.getElementsByTagName('arr-st');
			arr_st_num = arr_name[0].getElementsByTagName('num');
			if (arr_st_num.length) 
				arr_st_num = arr_st_num[0].textContent;
			arr_name = arr_name[0].getElementsByTagName('nam');
			if (arr_name.length) 
				arr_name = arr_name[0].textContent;
			//feed += '<div class="topHeader center">' + dep_name + ' - ' + arr_name + ' (с пересадками)</div>';
			
			GUI.menulist = '<div>';
			//Выбранная станция пересадки
			var chng_name = xhr.responseXML.getElementsByTagName('ch-st');
			if (chng_name.length) {
				current_name = chng_name[0].getElementsByTagName('nam');
				
				if (current_name.length) 
					current_name = current_name[0].textContent;
				
				//all change stations
				//feed += '<div class="topHeader center ">Пересадка на станции:</div>';
				for (var i = 1, count = 0; i < chng_name.length; i++) {
					curr_name = chng_name[i].getElementsByTagName('nam');
					if (curr_name.length) 
						curr_name = curr_name[0].textContent;
					curr_num = chng_name[i].getElementsByTagName('num');
					if (curr_num.length) 
						curr_num = curr_num[0].textContent;
					
					
					if (curr_name != current_name) {
						GUI.menulist += '<div class="buttontext_menu" onclick="Protocol.getRasp2Data(';
						GUI.menulist += Protocol.last_index1;
						GUI.menulist += ', ';
						GUI.menulist += Protocol.last_index2;
						GUI.menulist += ', \'';
						GUI.menulist += Protocol.last_date;
						GUI.menulist += '\', ';
						GUI.menulist += curr_num;
						GUI.menulist += ');" feedback="50">';
						GUI.menulist += curr_name;
						GUI.menulist += '</div>';
						count++;
					}
				}
			}
			GUI.menulist += '</div>';
			
			
			//Дата отправления. Значение может быть (пусто)
			var time = xhr.responseXML.getElementsByTagName('dat');
			if (time.length) 
				time = time[0].textContent;
			//if (time) feed += '<br/><div class="topHeader center">Дата: ' + time + '</div>';
			
			
			var trains = xhr.responseXML.getElementsByTagName('tra');
			//GUI.stationList = [];
			
			feed += '<br/><table style="width:100%">';
			for (var i = 0, len = trains.length; i < len; i++) {
			
				fir = trains[i].getElementsByTagName('fir');
				
				dep = fir[0].getElementsByTagName('dep');
				dep_time = dep[0].getElementsByTagName('tim');
				if (dep_time.length) 
					dep_time0 = dep_time[0].textContent;
				dep_name = dep[0].getElementsByTagName('nam');
				if (dep_name.length) 
					dep_name0 = dep_name[0].textContent;
				
				arr = fir[0].getElementsByTagName('arr');
				arr_time = arr[0].getElementsByTagName('tim');
				if (arr_time.length) 
					arr_time0 = arr_time[0].textContent;
				arr_name = arr[0].getElementsByTagName('nam');
				if (arr_name.length) 
					arr_name0 = arr_name[0].textContent;
				arr_url = arr[0].getElementsByTagName('url');
				if (arr_url.length) 
					arr_url = arr_url[0].textContent;
				
				
				sec = trains[i].getElementsByTagName('sec');
				
				dep = sec[0].getElementsByTagName('dep');
				dep_time = dep[0].getElementsByTagName('tim');
				if (dep_time.length) 
					dep_time1 = dep_time[0].textContent;
				dep_name = dep[0].getElementsByTagName('nam');
				if (dep_name.length) 
					dep_name1 = dep_name[0].textContent;
				dep_url = dep[0].getElementsByTagName('url');
				if (dep_url.length) 
					dep_url = dep_url[0].textContent;
				
				arr = sec[0].getElementsByTagName('arr');
				arr_time = arr[0].getElementsByTagName('tim');
				if (arr_time.length) 
					arr_time1 = arr_time[0].textContent;
				arr_name = arr[0].getElementsByTagName('nam');
				if (arr_name.length) 
					arr_name1 = arr_name[0].textContent;
				
				
				//ch-tim	Время ожидания на станции пересадки
				ch_tim = trains[i].getElementsByTagName('ch-tim');
				if (ch_tim.length) 
					ch_tim = ch_tim[0].textContent;
				
				//ch-hel-tex	Вспомогательный текст о том, как пересесть на второй поезд
				ch_hel_tex = trains[i].getElementsByTagName('ch-hel-tex');
				if (ch_hel_tex.length) 
					ch_hel_tex = ch_hel_tex[0].textContent;
				
				//tr-tim	Общее время в пути
				tr_tim = trains[i].getElementsByTagName('tr-tim');
				if (tr_tim.length) 
					tr_tim = tr_tim[0].textContent;
				
				
				//GUI.trainList[i] = splitUrl0;
				arr_url = arr_url.split('=')[1];
				
				if (i != 0) 
					feed += '<tr><td colspan="3" class="setBorder"></td></tr>';
				
				feed += '<tr><td class="time_rt2" onclick="Protocol.getStationData(' + dep_st_num + ')">';
				feed += dep_time0;
				feed += '</td><td class="time_wait2" onclick="Protocol.getStationData(' + arr_url + ')">';
				feed += arr_time0;
				feed += '<span style="font-weight:bold;"> пересадка </span>';
				feed += dep_time1;
				feed += '</td><td class="time_rt2" onclick="Protocol.getStationData(' + arr_st_num + ')">';
				feed += arr_time1;
				feed += '</td></tr>';
				
				feed += '<tr><td class="stations_rt2" colspan="3">';
				feed += ch_hel_tex;
				feed += '</td></tr>';
			}
			feed += '</table>';
			feed += '<br/><br/><br/>';
			
			//Attach the Feed to the HTML
			if (GUI.currentScreen == 'selectRasp2') {
				$('content').innerHTML = feed;
				if (count != 0) {
					Helper.show('menubottom', true);
				}
				Main.onscroll();
			}
		} else {
			//Handle other scenarios, such as timeouts...
			if (GUI.currentScreen == 'selectRasp2') {
				$('content').innerHTML = '<div class="dateSelect">Сервер недоступен! Проверьте настройки соединения.</div>';
			}
			Main.onscroll();
		}
	} else {
	}
}




//on get current stations on map;
Protocol.onGetCurrentStations = function() {
	if (xhr.readyState == 4 && xhr.responseText) {
		console.log("Protocol.onGetCurrentStations success loaded ");
		
		var dataList = xhr.responseText.split(/\n/);
		
		for (var i = 0, len = dataList.length; i < len - 1; i++) {
		
			var elementList = dataList[i].split(/\s*,\s*/);
			//console.log( 'index: ' + elementList[0] + '   x: ' + elementList[1] + '   y: ' + elementList[2] );
			GUI.currentStations[i] = {
				index: parseInt(elementList[0]),
				x: parseInt(elementList[1]),
				y: parseInt(elementList[2])
			};
		}
	} else {
		console.log("Protocol.onGetCurrentStations error ");
	}
}


/////////////////////////////////////////////////


Protocol.checkDate = function(_date ) {
	var tempArray = _date.split('.');
	_date = '';
	for (var i = 0; i < tempArray.length - 1; i++) {
		if (i != 0) 
			_date += '.'; 
		_date += tempArray[i];
	}
	return _date;
}


Protocol.checkHour = function(_hour){
	if ( _hour == 0 ) return '';
	
	if ( _hour%10 == 1) 
		return _hour + ' час ';
	else if (_hour%10 > 1 && _hour%10 < 5) 
		return _hour + ' часа ';
	else if (_hour%10 >= 5 || _hour%10 == 0) 
		return _hour + ' часов ';
}

Protocol.checkMin = function(_min){
	if ( _min == 0 ) return '';
	
	if ( _min%10 == 1) 
		return _min + ' минута ';
	else if (_min%10 > 1 && _min%10 < 5) 
		return _min + ' минуты ';
	else if (_min%10 >= 5 || _min%10 == 0) 
		return _min + ' минут ';
}

Protocol.checkSec = function(_sec){
	if ( _sec == 0 ) return '';
	
	if ( _sec%10 == 1) 
		return _sec + ' секунда ';
	else if (_sec%10 > 1 && _sec%10 < 5) 
		return _sec + ' секунды ';
	else if (_sec%10 >= 5 || _sec%10 == 0) 
		return _sec + ' секунд ';
}