﻿var GPS = {}

var so = null;
var latitude;
var longitude;
var getCoord;

GPS.init = function(){
    console.log('GPS.init();');
    try {
        so = device.getServiceObject('Service.Location', 'ILocation');
    } 
    catch (e) {
        //alert( 'so: ' + e );
    }
    
    return true;
}

GPS.deInit = function(){
    console.log('GPS.deInit();');
}


function getLocation(){
    console.log('GPS.getLocation();');
    GUI.clearData();
	
    if (getCoord == 'received') {
        showScreen();
        return;
    }
    
	if ( !so ) {
		 $('content').innerHTML = '</br><div class="topHeader center">' + define.NO_GPS + '</div>';
         getCoord = 'error';
		 return;
	}
	
    if (getCoord == 'error') getCoord = 'none';
    //console.log('device: ' + device);
    
    var updateoptions = new Object();
    updateoptions.PartialUpdates = false;
    
    var criteria = new Object();
    criteria.LocationInformationClass = "GenericLocationInfo";
    criteria.Updateoptions = updateoptions;

    try {
        var result = so.ILocation.GetLocation(criteria);
        //console.log('result: ' + result.ErrorCode);
        //alert( 'result: ' + result.ErrorCode );
        latitude = result.ReturnValue.Latitude;
        longitude = result.ReturnValue.Longitude;
        //console.log('latitude:' + latitude + '  longitude:' + longitude);
        //alert( 'latitude:' + latitude + '  longitude:' + longitude );
        
        if (latitude != null && longitude != null) {
            //console.log('getcoord ! received ');
            //alert( 'getcoord ! received ' );
            
            getCoord = 'received';
            showScreen();
        } else {
            $('content').innerHTML = '</br><div class="topHeader center">' + define.NO_GPS + '</div>';
            getCoord = 'error';
		}
    } 
    catch (e) {
        if (getCoord == 'none') {
            $('content').innerHTML = '</br><div class="topHeader center">' + define.NO_GPS + '</div>';
            getCoord = 'error';
        }
        console.log(' ' + e);
        //alert(' ' + e);
    }
}

function getLocationAsync(){
    console.log('GPS.getLocationAsync();');
    GUI.clearData();
	
    if (getCoord == 'received') {
        showScreen();
        return;
    }
    
   	if ( !so ) {
		 $('content').innerHTML = '</br><div class="topHeader center">' + define.NO_GPS + '</div>';
         getCoord = 'error';
		 return;
	}

    if (getCoord == 'error') 
        getCoord = 'none';
    //window.setTimeout( 'GPS.onTimeOut();', 5000 );
    //console.log('device: ' + device);
    
    var updateoptions = new Object();
    updateoptions.PartialUpdates = false;
    
    var criteria = new Object();
    criteria.LocationInformationClass = "GenericLocationInfo";
    criteria.Updateoptions = updateoptions;
    
    try {
        var result = so.ILocation.GetLocation(criteria, onGetLocation);
        //console.log('result: ' + result.ErrorCode);
        //alert('result: ' + result.ErrorCode);
    } 
    catch (e) {
        if (getCoord == 'none') {
            $('content').innerHTML = '</br><div class="topHeader center">' + define.NO_GPS + '</div>';
            getCoord = 'error';
        }
        console.log(' ' + e);
        //alert(' ' + e);
    }
}


function errorCB(positionError){
    console.log('GPS.errorCB(); ' + positionError.message);
    //alert( 'GPS.errorCB(); ' + positionError.message );
    
    if (getCoord == 'none') {
        //console.log('GPS.onTimeOut(); ' + getCoord);
        $('content').innerHTML = '</br><div class="topHeader center">' + define.NO_GPS + '</div>';
        getCoord = 'error';
    }
}

function onTimeOut(){
    console.log('GPS.onTimeOut(); ' + getCoord);
    //alert( 'GPS.onTimeOut(); ' + getCoord );
    
    if (getCoord == 'none') {
        //console.log('GPS.onTimeOut(); ' + getCoord);
        $('content').innerHTML = '</br><div class="topHeader center">' + define.NO_GPS + '</div>';
        getCoord = 'error';
    }
}


//Callback function that receives the result as parameter.
function onGetLocation(transId, eventCode, result){
    //console.log('GPS.onGetLocation     transId: ' + transId + '  eventCode: ' + eventCode + '  result: ' + result);
    //alert( 'GPS.onGetLocation     transId: ' + transId + '  eventCode: ' + eventCode + '  result: ' + result);
    
    latitude = result.ReturnValue.Latitude;
    longitude = result.ReturnValue.Longitude;
    //console.log('latitude:' + latitude + '  longitude:' + longitude);
    //alert( 'latitude:' + latitude + '  longitude:' + longitude );
    
    if (latitude != null && longitude != null) {
        //console.log('getcoord ! received ');
        //alert( 'getcoord ! received ' );
        
        getCoord = 'received';
        showScreen();
    }
}


function showScreen(){
    console.log('GPS.showScreen();');
    //alert( 'GPS.showScreen();' );
    
    //latitude = 58.42307209968567;
    //longitude = 31.112001895904541;
    
    var stations = new Array();
    for (var i = 0, len = GUI.currentCityStations[GUI.currentCity].length; i < len; i++) {
    
        var dist = getDist(GUI.currentCityStations[GUI.currentCity][i].latitude, GUI.currentCityStations[GUI.currentCity][i].longitude);
        stations.push({
            name: GUI.currentCityStations[GUI.currentCity][i].name,
            index: GUI.currentCityStations[GUI.currentCity][i].index,
            dist: dist
        });
    }
    //console.log('stations.length: ' + stations.length);
    stations.sort(srtDst);
    
    var feed = '';
    feed += '</br><div class="topHeader center">' + define.GPS_NEAR + '</div></br>'
    
    var i = 0;
    while (i < stations.length && i < 10) {
        //feed += '<div class="center gpsStation" onclick="Protocol.getStationData(' + stations[i].index + ');">' +
		feed += '<div class="dateSelect" onclick="Protocol.getStationData(' + stations[i].index + ');">' +
		stations[i].name +
        ' (' +
        Math.round(stations[i].dist) +
        define.GPS_KM +
        ')</div>';
        i++;
    }
    feed += '<br/><br/><br/>';
    $('content').innerHTML = feed;
	Main.onscroll();
}



//distance between points using gps coord
function getDist(lat2, long2){
    R = 6371;
    lat1 = latitude;
    long1 = longitude;
    
    lat1 *= Math.PI / 180;
    long1 *= Math.PI / 180;
    lat2 *= Math.PI / 180;
    long2 *= Math.PI / 180;
    
    cosd = Math.sin(lat1) * Math.sin(lat2) + Math.cos(lat1) * Math.cos(lat2) * Math.cos(long1 - long2);
    dist = Math.acos(cosd) * R;
    return dist;
}

function srtDst(a, b){
    return (a.dist > b.dist ? 1 : -1);
}


